diff --git a/app/controllers/usergroups_controller.rb b/app/controllers/usergroups_controller.rb
index 3b43c0a73..1eca10ebc 100644
--- a/app/controllers/usergroups_controller.rb
+++ b/app/controllers/usergroups_controller.rb
@@ -1,6 +1,9 @@
 class UsergroupsController < ApplicationController
+  include Foreman::Controller::AutoCompleteSearch
+  before_filter :find_by_name, :only => [:edit, :update, :destroy]
+
   def index
-    @usergroups = Usergroup.paginate :page => params[:page]
+    @usergroups = resource_base.paginate :page => params[:page]
   end
 
   def new
@@ -17,24 +20,30 @@ class UsergroupsController < ApplicationController
   end
 
   def edit
-    @usergroup = Usergroup.find(params[:id])
   end
 
   def update
-    @usergroup = Usergroup.find(params[:id])
     if @usergroup.update_attributes(params[:usergroup])
       process_success
     else
       process_error
     end
+  rescue Foreman::CyclicGraphException => e
+    @usergroup.errors[:usergroups] = e.record.errors[:base].join(' ')
+    process_error
   end
 
   def destroy
-    @usergroup = Usergroup.find(params[:id])
     if @usergroup.destroy
       process_success
     else
       process_error
     end
   end
+
+  private
+
+  def find_by_id(permission = :view_usergroups)
+    Usergroup.authorized(permission).find(params[:id])
+  end
 end
diff --git a/app/controllers/users_controller.rb b/app/controllers/users_controller.rb
index afc426752..8e81dce4b 100644
--- a/app/controllers/users_controller.rb
+++ b/app/controllers/users_controller.rb
@@ -2,14 +2,14 @@ class UsersController < ApplicationController
   include Foreman::Controller::AutoCompleteSearch
   include Foreman::Controller::UsersMixin
 
-  before_filter :find_resource, :only => [:edit, :update, :destroy]
   skip_before_filter :require_mail, :only => [:edit, :update, :logout]
   skip_before_filter :require_login, :authorize, :session_expiry, :update_activity_time, :set_taxonomy, :set_gettext_locale_db, :only => [:login, :logout, :extlogout]
   skip_before_filter :authorize, :only => :extlogin
   after_filter       :update_activity_time, :only => :login
+  skip_before_filter :update_admin_flag, :only => :update
 
   def index
-    @users = User.search_for(params[:search], :order => params[:order]).includes(:auth_source).paginate(:page => params[:page])
+    @users = User.authorized(:view_users).search_for(params[:search], :order => params[:order]).includes(:auth_source).paginate(:page => params[:page])
   end
 
   def new
@@ -26,6 +26,7 @@ class UsersController < ApplicationController
 
   def edit
     editing_self?
+    @user = find_resource(:edit_users)
     if @user.user_facts.count == 0
       user_fact = @user.user_facts.build :operator => "==", :andor => "or"
       user_fact.fact_name_id = FactName.first.id if FactName.first
@@ -33,6 +34,9 @@ class UsersController < ApplicationController
   end
 
   def update
+    editing_self?
+    @user = find_resource(:edit_users)
+    update_admin_flag
     if @user.update_attributes(params[:user])
       update_sub_hostgroups_owners
 
@@ -43,6 +47,7 @@ class UsersController < ApplicationController
   end
 
   def destroy
+    @user = find_resource(:destroy_users)
     if @user == User.current
       notice _("You are currently logged in, suicidal?")
       redirect_to :back and return
@@ -102,8 +107,8 @@ class UsersController < ApplicationController
 
   private
 
-  def find_resource
-    @user ||= User.find(params[:id])
+  def find_resource(permission = :view_users)
+    editing_self? ? User.current : User.authorized(permission).find(params[:id])
   end
 
   def login_user(user)
diff --git a/app/helpers/ancestry_helper.rb b/app/helpers/ancestry_helper.rb
index a4a816ba8..0c13255f8 100644
--- a/app/helpers/ancestry_helper.rb
+++ b/app/helpers/ancestry_helper.rb
@@ -1,7 +1,7 @@
 module AncestryHelper
 
   # this helper is used for hostgroup names and location/organization names.  Both have ancestry
-  def label_with_link(obj, max_length = 1000)
+  def label_with_link(obj, max_length = 1000, authorizer = nil)
     return if obj.blank?
     options = (obj.title.to_s.size > max_length) ? { :'data-original-title' => obj.title, :rel => 'twipsy' } : {}
     nesting = obj.title.to_s.gsub(/[^\/]+\/?$/, '')
@@ -10,7 +10,7 @@ module AncestryHelper
     link_to_if_authorized(
       content_tag(:span,
                   content_tag(:span, nesting, :class => 'gray') + name, options),
-      send("hash_for_edit_#{obj.class.name.tableize.singularize}_path", obj))
+      send("hash_for_edit_#{obj.class.name.tableize.singularize}_path", obj).merge(:auth_object => obj, :authorizer => authorizer))
   end
 
-end
\ No newline at end of file
+end
diff --git a/app/helpers/application_helper.rb b/app/helpers/application_helper.rb
index 68ca18e65..e02279e48 100644
--- a/app/helpers/application_helper.rb
+++ b/app/helpers/application_helper.rb
@@ -113,31 +113,39 @@ module ApplicationHelper
     options
   end
 
-  def check_all_roles_links
-    link_to(_("Check all"), "#", :id => "check_all_roles", :remote => true) +
-    link_to(_("Uncheck all"), "#", :id => "uncheck_all_roles", :remote => true)
-  end
-
   # Return true if user is authorized for controller/action, otherwise false
-  # +controller+ : String or symbol for the controller
-  # +action+     : String or symbol for the action
-  def authorized_for(controller, action, id = nil)
-    User.current.allowed_to?({:controller => controller, :action => action, :id => id}) rescue false
+  # +options+ : Hash containing
+  #             :controller : String or symbol for the controller, defaults to params[:controller]
+  #             :action     : String or symbol for the action
+  #             :id         : Id parameter
+  #             :auth_action: String or symbol for the action, this has higher priority that :action
+  #             :auth_object: Specific object on which we may verify particular permission
+  #             :authorizer : Specific authorizer to perform authorization on (handy to inject authorizer with base collection)
+  #             :permission : Specific permission to check authorization on (handy on custom permission names)
+  def authorized_for(options)
+    action          = options.delete(:auth_action) || options.delete(:action)
+    object          = options.delete(:auth_object)
+    user            = User.current
+    controller      = options[:controller] || params[:controller]
+    controller_name = controller.to_s.gsub(/::/, "_").underscore
+    id              = options[:id]
+    permission      = options.delete(:permission) || [action, controller_name].join('_')
+
+    if object.nil?
+      user.allowed_to?({ :controller => controller_name, :action => action, :id => id }) rescue false
+    else
+      authorizer = options.delete(:authorizer) || Authorizer.new(user)
+      authorizer.can?(permission, object) rescue false
+    end
   end
 
   # Display a link if user is authorized, otherwise a string
   # +name+    : String to be displayed
-  # +options+ : Hash containing
-  #             :controller  : String or Symbol representing the controller
-  #             :auth_action : String or Symbol representing the action to be used for authorization checks
+  # +options+ : Hash containing options for authorized_for and link_to
   # +html_options+ : Hash containing html options for the link or span
   def link_to_if_authorized(name, options = {}, html_options = {})
-    auth_options = {
-      :controller => options[:controller]         || params[:controller],
-      :action     => options.delete(:auth_action) || options[:action],
-      :id         => options[:id]
-    }
-    if User.current.allowed_to?(auth_options)
+    enable_link = authorized_for(options)
+    if enable_link
       link_to name, options, html_options
     else
       link_to_function name, nil, html_options.merge!(:class => "#{html_options[:class]} disabled", :disabled => true)
@@ -149,16 +157,14 @@ module ApplicationHelper
     html_options = {:confirm => _('Are you sure?'), :method => :delete, :class => 'delete'}.merge(html_options)
     display_link_if_authorized(_("Delete"), options, html_options)
   end
+
   # Display a link if user is authorized, otherwise nothing
   # +name+    : String to be displayed
-  # +options+ : Hash containing
-  #             :controller  : String or Symbol representing the controller
-  #             :auth_action : String or Symbol representing the action to be used for authorization checks
+  # +options+ : Hash containing options for authorized_for and link_to
   # +html_options+ : Hash containing html options for the link or span
   def display_link_if_authorized(name, options = {}, html_options = {})
-    auth_action = options.delete :auth_action
     enable_link = html_options.has_key?(:disabled) ? !html_options[:disabled] : true
-    if enable_link and authorized_for(options[:controller] || params[:controller], auth_action || options[:action])
+    if enable_link and authorized_for(options)
       link_to(name, options, html_options)
     else
       ""
@@ -166,7 +172,9 @@ module ApplicationHelper
   end
 
   def authorized_edit_habtm klass, association, prefix = nil, options = {}
-    return edit_habtm(klass, association, prefix, options) if authorized_for params[:controller], params[:action]
+    if authorized_for :controller => params[:controller], :action => params[:action]
+      return edit_habtm(klass, association, prefix, options)
+    end
     show_habtm klass.send(association.name.pluralize.downcase)
   end
 
@@ -198,7 +206,7 @@ module ApplicationHelper
   end
 
   def auto_complete_search(name, val, options = {})
-    path = send("#{controller_name}_path")
+    path = options[:path] || send("#{controller_name}_path")
     options.merge!(:class => "autocomplete-input form-control", :'data-url' => "#{path}/auto_complete_#{name}" )
     text_field_tag(name, val, options)
   end
diff --git a/app/helpers/autosign_helper.rb b/app/helpers/autosign_helper.rb
index 1aa0784f1..7d0729d84 100644
--- a/app/helpers/autosign_helper.rb
+++ b/app/helpers/autosign_helper.rb
@@ -1,6 +1,6 @@
 module AutosignHelper
 
   def autosign_form
-    link_to "New", new_smart_proxy_autosign_path(@proxy) if authorized_for("SmartProxies::Autosign", :create)
+    link_to "New", new_smart_proxy_autosign_path(@proxy) if authorized_for(:controller => "SmartProxies::Autosign", :action => :create, :auth_object => @proxy)
   end
 end
diff --git a/app/helpers/bmc_helper.rb b/app/helpers/bmc_helper.rb
index 713750782..a4c816288 100644
--- a/app/helpers/bmc_helper.rb
+++ b/app/helpers/bmc_helper.rb
@@ -11,20 +11,22 @@ module BmcHelper
   def power_actions
     action_buttons(
       (PowerManager::SUPPORTED_ACTIONS - ['state']).map do |action|
-        display_link_if_authorized(_(action.to_s.capitalize), { :action => "power", :id => @host, :power_action => action},
+        display_link_if_authorized(_(action.to_s.capitalize),
+                                   { :action => "power", :id => @host, :power_action => action, :auth_object => @host },
                                    :confirm => _('Are you sure?'), :method => :put)
       end
     )
   end
 
   def boot_actions
-    controller_options = { :action => "ipmi_boot", :id => @host }
+    controller_options = { :action => "ipmi_boot", :id => @host, :auth_object => @host, :permission => 'ipmi_boot' }
 
     confirm = _('Are you sure?')
 
     links = HostsController::BOOT_DEVICES.map do |device,label|
-       display_link_if_authorized(_(label), controller_options.merge(:ipmi_device => device),
-                                  :confirm => confirm, :method => :put)
+      display_link_if_authorized(_(label),
+                                 controller_options.merge(:ipmi_device => device),
+                                 :confirm => confirm, :method => :put)
     end
     action_buttons("Select device", links)
   end
diff --git a/app/helpers/common_parameters_helper.rb b/app/helpers/common_parameters_helper.rb
index a0fc1f4e1..f27021589 100644
--- a/app/helpers/common_parameters_helper.rb
+++ b/app/helpers/common_parameters_helper.rb
@@ -1,10 +1,8 @@
 module CommonParametersHelper
   # Return true if user is authorized for controller/action OR controller/action@type, otherwise false
-  def authorized_via_my_scope(controller, action)
-    return true if authorized_for(controller, action)
-
-    operation = "#{action}_my_#{controller.singularize}".to_sym
-    User.current.allowed_to?(operation) and User.current.send(controller).include?(instance_variable_get("@#{controller.singularize}"))
+  # third argument may be specific object (usually for edit and destroy actions)
+  def authorized_via_my_scope(controller, action, object = nil)
+    authorized_for(:controller => controller, :action => action, :auth_object => object)
   end
 
   def parameters_title
diff --git a/app/helpers/compute_resources_helper.rb b/app/helpers/compute_resources_helper.rb
index 21c2aa01d..366757c9c 100644
--- a/app/helpers/compute_resources_helper.rb
+++ b/app/helpers/compute_resources_helper.rb
@@ -21,16 +21,16 @@ module ComputeResourcesHelper
     "class='label #{s ? "label-success" : "label-default"}'".html_safe
   end
 
-  def vm_power_action vm
-    opts = hash_for_power_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity)
+  def vm_power_action vm, authorizer = nil
+    opts = hash_for_power_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity).merge(:auth_object => @compute_resource, :permission => 'power_compute_resources_vms', :authorizer => authorizer)
     html = vm.ready? ? { :confirm =>_("Are you sure you want to power %{act} %{vm}?") % { :act => action_string(vm).downcase.strip, :vm => vm } , :class => "btn btn-danger" } :
                        { :class => "btn btn-info" }
 
     display_link_if_authorized "Power #{action_string(vm)}", opts, html.merge(:method => :put)
   end
 
-  def vm_pause_action vm
-    opts = hash_for_pause_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity)
+  def vm_pause_action vm, authorizer = nil
+    opts = hash_for_pause_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity).merge(:auth_object => @compute_resource, :permission => 'power_compute_resources_vms', :authorizer => authorizer)
     pause_action = vm.ready? ? _('Pause') : _('Resume')
     html = vm.state.downcase == 'paused' ? { :class => "btn btn-info" } :
                                            { :confirm =>_("Are you sure you want to %{act} %{vm}?") % { :act => pause_action.downcase, :vm => vm } , :class => "btn btn-danger" }
diff --git a/app/helpers/compute_resources_vms_helper.rb b/app/helpers/compute_resources_vms_helper.rb
index 49a2f91bf..1af1b3b9a 100644
--- a/app/helpers/compute_resources_vms_helper.rb
+++ b/app/helpers/compute_resources_vms_helper.rb
@@ -3,10 +3,10 @@ module ComputeResourcesVmsHelper
   # little helper to help show VM properties
   def prop method, title = nil
     content_tag :tr do
-      result = content_tag :td do
+      result = content_tag(:td) do
         title || method.to_s.humanize
       end
-      result += content_tag :td do
+      result += content_tag(:td) do
         value = @vm.send(method) rescue nil
         case value
         when Array
@@ -67,32 +67,32 @@ module ComputeResourcesVmsHelper
     end
   end
 
-  def available_actions(vm)
+  def available_actions(vm, authorizer = nil)
     case vm
     when Fog::Compute::OpenStack::Server
-      openstack_available_actions(vm)
+      openstack_available_actions(vm, authorizer)
     else
-      default_available_actions(vm)
+      default_available_actions(vm, authorizer)
     end
   end
 
-  def openstack_available_actions(vm)
+  def openstack_available_actions(vm, authorizer = nil)
     actions = []
     if vm.state == 'ACTIVE'
-      actions << vm_power_action(vm)
-      actions << vm_pause_action(vm)
+      actions << vm_power_action(vm, authorizer)
+      actions << vm_pause_action(vm, authorizer)
     elsif vm.state == 'PAUSED'
-      actions << vm_pause_action(vm)
+      actions << vm_pause_action(vm, authorizer)
     else
-      actions << vm_power_action(vm)
+      actions << vm_power_action(vm, authorizer)
     end
 
-    actions << display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity))
+    actions << display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity).merge(:auth_object => @compute_resource, :authorizer => authorizer))
   end
 
-  def default_available_actions(vm)
-    [vm_power_action(vm),
-     display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity))]
+  def default_available_actions(vm, authorizer = nil)
+    [vm_power_action(vm, authorizer),
+     display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity).merge(:auth_object => @compute_resource, :authorizer => authorizer))]
   end
 
   def vpc_security_group_hash(security_groups)
diff --git a/app/helpers/dashboard_helper.rb b/app/helpers/dashboard_helper.rb
index 070af99a9..81d853ccd 100644
--- a/app/helpers/dashboard_helper.rb
+++ b/app/helpers/dashboard_helper.rb
@@ -39,7 +39,7 @@ module DashboardHelper
 
   def latest_events
     # 6 reports + header fits the events box nicely...
-    summary = Report.my_reports.interesting.search_for('reported > "7 days ago"').limit(6)
+    summary = Report.authorized(:view_reports).my_reports.interesting.search_for('reported > "7 days ago"').limit(6)
   end
 
   def translated_header(shortname, longname)
diff --git a/app/helpers/filters_helper.rb b/app/helpers/filters_helper.rb
new file mode 100644
index 000000000..05f0bf6b2
--- /dev/null
+++ b/app/helpers/filters_helper.rb
@@ -0,0 +1,22 @@
+module FiltersHelper
+  def search_path(type)
+    if type.nil?
+      ''
+    else
+      case type
+        when 'Image'
+          '' # images are nested resource for CR, we can't autocomplete
+        when 'HostClass'
+          '' # host classes is only used in API
+        when 'Parameter'
+          '' # parameter is only used in API
+        else
+          resource_path(type) + '/auto_complete_search'
+      end
+    end
+  end
+
+  def resource_path(type)
+    send(type.pluralize.underscore + '_path')
+  end
+end
diff --git a/app/helpers/hosts_and_hostgroups_helper.rb b/app/helpers/hosts_and_hostgroups_helper.rb
index 30ff7124e..244d2318b 100644
--- a/app/helpers/hosts_and_hostgroups_helper.rb
+++ b/app/helpers/hosts_and_hostgroups_helper.rb
@@ -8,7 +8,7 @@ module HostsAndHostgroupsHelper
   end
 
   def accessible_hostgroups
-    hg = (User.current.hostgroups.any? and !User.current.admin?) ? User.current.hostgroups.with_taxonomy_scope_override(@location,@organization) : Hostgroup.with_taxonomy_scope_override(@location,@organization)
+    hg = Hostgroup.with_taxonomy_scope_override(@location,@organization)
     hg.sort{ |l, r| l.to_label <=> r.to_label }
   end
 
@@ -19,7 +19,7 @@ module HostsAndHostgroupsHelper
   end
 
   def accessible_domains
-    (User.current.domains.any? and !User.current.admin?) ? User.current.domains.with_taxonomy_scope_override(@location,@organization) : Domain.with_taxonomy_scope_override(@location,@organization)
+    Domain.with_taxonomy_scope_override(@location,@organization)
   end
 
   def domain_subnets(domain=@domain)
diff --git a/app/helpers/hosts_helper.rb b/app/helpers/hosts_helper.rb
index 4ea526333..b2a49b59b 100644
--- a/app/helpers/hosts_helper.rb
+++ b/app/helpers/hosts_helper.rb
@@ -68,7 +68,8 @@ module HostsHelper
   end
 
   def authorized?
-    authorized_for(:hosts, :edit) or authorized_for(:hosts, :destroy)
+    authorized_for(:controller => :hosts, :action => :edit) or
+        authorized_for(:controller => :hosts, :action => :destroy)
   end
 
   def searching?
@@ -226,12 +227,14 @@ module HostsHelper
   def host_title_actions(host, vm)
     title_actions(
         button_group(
-            link_to_if_authorized(_("Edit"), hash_for_edit_host_path(:id => host), :title => _("Edit your host")),
+            link_to_if_authorized(_("Edit"), hash_for_edit_host_path(:id => host).merge(:auth_object => host), :title => _("Edit your host")),
             if host.build
-              link_to_if_authorized(_("Cancel Build"), hash_for_cancelBuild_host_path(:id => host), :disabled => host.can_be_built?,
+              link_to_if_authorized(_("Cancel Build"), hash_for_cancelBuild_host_path(:id => host).merge(:auth_object => host, :permission => 'build_hosts'),
+                                    :disabled => host.can_be_built?,
                                     :title                                                                 => _("Cancel build request for this host"))
             else
-              link_to_if_authorized(_("Build"), hash_for_setBuild_host_path(:id => host), :disabled => !host.can_be_built?,
+              link_to_if_authorized(_("Build"), hash_for_setBuild_host_path(:id => host).merge(:auth_object => host, :permission => 'build_hosts'),
+                                    :disabled => !host.can_be_built?,
                                     :title                                                       => _("Enable rebuild on next host boot"),
                                     :confirm                                                     => _("Rebuild %s on next reboot?\nThis would also delete all of its current facts and reports") % host)
             end
@@ -240,22 +243,24 @@ module HostsHelper
           button_group(
               if vm
                 html_opts = vm.ready? ? {:confirm => _('Are you sure?'), :class => "btn btn-danger"} : {:class => "btn btn-success"}
-                link_to_if_authorized _("Power%s") % state(vm.ready?), hash_for_power_host_path(:power_action => vm.ready? ? :stop : :start), html_opts.merge(:method => :put)
+                link_to_if_authorized _("Power%s") % state(vm.ready?), hash_for_power_host_path(:power_action => vm.ready? ? :stop : :start).merge(:auth_object => host, :permission => 'power_hosts'),
+                                      html_opts.merge(:method => :put)
               else
                 link_to(_("Unknown Power State"), '#', :disabled => true, :class => "btn btn-warning")
               end +
-                  link_to_if_authorized(_("Console"), hash_for_console_host_path(), {:disabled => vm.nil? || !vm.ready?, :class => "btn btn-info"})
+                  link_to_if_authorized(_("Console"), hash_for_console_host_path().merge(:auth_object => host, :permission => 'console_hosts'),
+                                        {:disabled => vm.nil? || !vm.ready?, :class => "btn btn-info"})
           )
         end,
         button_group(
           if host.try(:puppet_proxy)
-            link_to_if_authorized(_("Run puppet"), hash_for_puppetrun_host_path(:id => host).merge(:auth_action => :edit),
+            link_to_if_authorized(_("Run puppet"), hash_for_puppetrun_host_path(:id => host).merge(:auth_object => host, :permission => 'puppetrun_hosts'),
                                   :disabled => !Setting[:puppetrun],
                                   :title => _("Trigger a puppetrun on a node; requires that puppet run is enabled"))
           end
         ),
         button_group(
-            link_to_if_authorized(_("Delete"), hash_for_host_path(:id => host, :auth_action => :destroy),
+            link_to_if_authorized(_("Delete"), hash_for_host_path(:id => host).merge(:auth_object => host, :permission => 'destroy_hosts'),
                                   :class => "btn btn-danger", :confirm => _('Are you sure?'), :method => :delete)
         )
     )
diff --git a/app/helpers/layout_helper.rb b/app/helpers/layout_helper.rb
index c5bd2510b..8e709c096 100644
--- a/app/helpers/layout_helper.rb
+++ b/app/helpers/layout_helper.rb
@@ -125,6 +125,20 @@ module LayoutHelper
     end
   end
 
+  def autocomplete_f(f, attr, options = {})
+    field(f, attr, options) do
+      path = options.delete(:path) || send("#{f.object.class.pluralize.underscore}_path")
+      auto_complete_search(attr,
+                           f.object.send(attr).try(:squeeze, " "),
+                           options.merge(
+                               :placeholder => _("Filter") + ' ...',
+                               :path        => path,
+                                :name       => "#{f.object_name}[#{attr}]"
+                          )
+      ).html_safe
+    end
+  end
+
   def field(f, attr, options = {})
     error = f.object.errors[attr] if f && f.object.respond_to?(:errors)
     help_inline = help_inline(options.delete(:help_inline), error)
@@ -132,7 +146,9 @@ module LayoutHelper
     help_block  = content_tag(:span, options.delete(:help_block), :class => "help-block")
     size_class = options.delete(:size) || "col-md-4"
     content_tag(:div, :class=> "clearfix") do
-    content_tag :div, :class => "form-group #{error.empty? ? "" : 'has-error'}" do
+    content_tag :div, :class => "form-group #{error.empty? ? "" : 'has-error'}",
+               :id          => options.delete(:control_group_id) do
+
       label   = options.delete(:label)
       label ||= ((clazz = f.object.class).respond_to?(:gettext_translation_for_attribute_name) &&
                   s_(clazz.gettext_translation_for_attribute_name attr)) if f
diff --git a/app/models/architecture.rb b/app/models/architecture.rb
index 3931baca3..ec71a941d 100644
--- a/app/models/architecture.rb
+++ b/app/models/architecture.rb
@@ -1,5 +1,5 @@
 class Architecture < ActiveRecord::Base
-  include Authorization
+  include Authorizable
 
   before_destroy EnsureNotUsedBy.new(:hosts, :hostgroups)
 
diff --git a/app/models/auth_source.rb b/app/models/auth_source.rb
index 98eb2b88c..5912e8bb7 100644
--- a/app/models/auth_source.rb
+++ b/app/models/auth_source.rb
@@ -16,8 +16,8 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 
 class AuthSource < ActiveRecord::Base
-  include Authorization
   audited :allow_mass_assignment => true
+
   before_destroy EnsureNotUsedBy.new(:users)
   has_many :users
 
diff --git a/app/models/bookmark.rb b/app/models/bookmark.rb
index f24dd5de1..493fb7ddd 100644
--- a/app/models/bookmark.rb
+++ b/app/models/bookmark.rb
@@ -1,4 +1,6 @@
 class Bookmark < ActiveRecord::Base
+  include Authorizable
+
   belongs_to :owner, :polymorphic => true
   attr_accessible :name, :controller, :query, :public
   audited :allow_mass_assignment => true
diff --git a/app/models/cached_user_role.rb b/app/models/cached_user_role.rb
new file mode 100644
index 000000000..2c7cb32f4
--- /dev/null
+++ b/app/models/cached_user_role.rb
@@ -0,0 +1,10 @@
+class CachedUserRole < ActiveRecord::Base
+  attr_accessible :role_id, :user_id, :user_role_id, :role, :user, :user_role
+
+  belongs_to :user
+  belongs_to :role
+
+  # this UserRole created this cache
+  belongs_to :user_role
+
+end
diff --git a/app/models/cached_usergroup_member.rb b/app/models/cached_usergroup_member.rb
new file mode 100644
index 000000000..56f0dee35
--- /dev/null
+++ b/app/models/cached_usergroup_member.rb
@@ -0,0 +1,7 @@
+class CachedUsergroupMember < ActiveRecord::Base
+  attr_accessible :user_id, :usergroup_id, :user, :usergroup
+
+  belongs_to :user
+  belongs_to :usergroup
+
+end
diff --git a/app/models/compute_profile.rb b/app/models/compute_profile.rb
index 43e09b6bd..43af9e761 100644
--- a/app/models/compute_profile.rb
+++ b/app/models/compute_profile.rb
@@ -1,6 +1,7 @@
 class ComputeProfile < ActiveRecord::Base
 
-  include Authorization
+  include Authorizable
+
   attr_accessible :name
   audited
   has_associated_audits
diff --git a/app/models/compute_resource.rb b/app/models/compute_resource.rb
index afcfc18bd..5b2d3acfd 100644
--- a/app/models/compute_resource.rb
+++ b/app/models/compute_resource.rb
@@ -2,6 +2,7 @@ require 'fog_extensions'
 class ComputeResource < ActiveRecord::Base
   include Taxonomix
   include Encryptable
+  include Authorizable
   encrypts :password
   SUPPORTED_PROVIDERS = %w[Libvirt Ovirt EC2 Vmware Openstack Rackspace GCE]
   PROVIDERS = SUPPORTED_PROVIDERS.reject { |p| !SETTINGS[p.downcase.to_sym] }
@@ -13,12 +14,12 @@ class ComputeResource < ActiveRecord::Base
   STI_PREFIX= "Foreman::Model"
 
   before_destroy EnsureNotUsedBy.new(:hosts)
-  include Authorization
   has_and_belongs_to_many :users, :join_table => "user_compute_resources"
   validates :name, :uniqueness => true, :format => { :with => /\A(\S+)\Z/, :message => N_("can't be blank or contain white spaces.") }
   validates :provider, :presence => true, :inclusion => { :in => PROVIDERS }
   validates :url, :presence => true
   scoped_search :on => :name, :complete_value => :true
+  scoped_search :on => :id, :complete_value => :true
   before_save :sanitize_url
   has_many_hosts
   has_many :images, :dependent => :destroy
@@ -36,19 +37,6 @@ class ComputeResource < ActiveRecord::Base
     end
   }
 
-  scope :my_compute_resources, lambda {
-    user = User.current
-    if user.admin?
-      conditions = { }
-    else
-      conditions = sanitize_sql_for_conditions([" (compute_resources.id in (?))", user.compute_resource_ids])
-      conditions.sub!(/\s*\(\)\s*/, "")
-      conditions.sub!(/^(?:\(\))?\s?(?:and|or)\s*/, "")
-      conditions.sub!(/\(\s*(?:or|and)\s*\(/, "((")
-    end
-    where(conditions).reorder('type, name')
-  }
-
   # allows to create a specific compute class based on the provider.
   def self.new_provider args
     raise ::Foreman::Exception.new(N_("must provide a provider")) unless provider = args[:provider]
@@ -243,22 +231,6 @@ class ComputeResource < ActiveRecord::Base
 
   private
 
-  def enforce_permissions operation
-    # We get called again with the operation being set to create
-    return true if operation == "edit" and new_record?
-    current = User.current
-    if current.allowed_to?("#{operation}_compute_resources".to_sym)
-      # If you can create compute resources then you can create them anywhere
-      return true if operation == "create"
-      # edit or delete
-      if current.allowed_to?("#{operation}_compute_resources".to_sym)
-        return true if ComputeResource.my_compute_resources.include? self
-      end
-    end
-    errors.add :base, _("You do not have permission to %s this compute resource") % operation
-    false
-  end
-
   def set_attributes_hash
     self.attrs ||= {}
   end
diff --git a/app/models/compute_resources/foreman/model/ec2.rb b/app/models/compute_resources/foreman/model/ec2.rb
index f38736f4d..52f4ee78e 100644
--- a/app/models/compute_resources/foreman/model/ec2.rb
+++ b/app/models/compute_resources/foreman/model/ec2.rb
@@ -91,7 +91,7 @@ module Foreman::Model
     end
 
     def associated_host(vm)
-      Host.my_hosts.where(:ip => [vm.public_ip_address, vm.private_ip_address]).first
+      Host.authorized(:view_hosts, Host).where(:ip => [vm.public_ip_address, vm.private_ip_address]).first
     end
 
     private
diff --git a/app/models/compute_resources/foreman/model/libvirt.rb b/app/models/compute_resources/foreman/model/libvirt.rb
index 79c8a9c76..a73f5bd01 100644
--- a/app/models/compute_resources/foreman/model/libvirt.rb
+++ b/app/models/compute_resources/foreman/model/libvirt.rb
@@ -127,7 +127,7 @@ module Foreman::Model
     end
 
     def associated_host(vm)
-      Host.my_hosts.where(:mac => vm.mac).first
+      Host.authorized(:view_hosts, Host).where(:mac => vm.mac).first
     end
 
     protected
